'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : Slusarenko V.P. Lubotin Ukrain                    *
'*  Notice  : Copyright (c) 2007 BW                             *
'*          : All Rights Reserved                               *
'*  Date    : 09.11.2007                                        *
'*  Version : 1.0 , , /                             *
'*  Notes   :  -.  3324            *
'*          : 16f876a, 4 MHz, LCD1602, AP TDA7313, PLL LM7001   *
'*     -2,5dB,  -77,5   *
'****************************************************************
Device=16F876A
'config 3F31     
'Config XT_OSC , WDT_OFF , PWRTE_ON , BODEN_OFF , LVP_OFF  ,CPD_OFF , CP_OFF , DEBUG_OFF
', WRTE_ON
'****************************************************************
' LCD should be connected as follows:
'       LCD     PIC
'       DB4     PortB.4
'       DB5     PortB.5
'       DB6     PortB.6
'       DB7     PortB.7
'       RS      PortA.0 (add 4.7K pullup resistor to 5 volts)
'       E       PortA.1
'       RW      Ground
'       Vdd     5 volts
'       Vss     Ground
'       Vo      20K potentiometer (or ground)
'       DB0-3   No connect
'-------------------------------------------------------------
Declare XTAL 4
Declare LCD_RSPIN=PORTA.0
Declare LCD_ENPIN=PORTA.1
Declare LCD_DTPIN=PORTB.4
Declare LCD_INTERFACE=4
Declare LCD_LINES=2

Declare SDA_PIN PORTC.4
Declare SCL_PIN PORTC.3
Declare SLOW_BUS On 
'===============================================================================
'  Conect bus i2c_send
'-------------------------------------------------------------------------------
    'SDA as PORTC.4
    'CLK as PORTC.3
'===============================================================================
'  Conect IC LM7001J
'-------------------------------------------------------------------------------
Symbol    d_lm = PORTC.0        '  
Symbol    c_lm = PORTC.1        ' 
Symbol    e_lm = PORTC.2        '  

'-------------------------------------------------------------------------------
'   Vareables
'-------------------------------------------------------------------------------
    Dim Vol As Byte
    Dim Tre As Byte
    Dim Balfl As Byte      '  ( )
    Dim Balfr As Byte      '  ( )
    Dim Balrl As Byte      '  ( )
    Dim Balrr As Byte      '  ( )
    Dim zero As Bit        '   0       
    Dim Bas As Byte
    Dim Loudness As Bit    '     
    Dim comutator As Byte
    Dim Flag As Byte       '      
    Dim Klav As Byte       ' 
    Dim menu_flag As Bit   ' .   
    
    Dim mono As Bit        '  /
    Dim bak_port As Bit     '   
    
    Dim Channel As Byte        '  
    Dim lcdFreq As Word        ' 
    Dim sintez  As $c0         '3-  : ,   50 
    Dim divisor As Word        '2  .  
    Dim adres_ch As 10         '     
    
    Dim row As Byte        ' 
    Dim ind As Byte        '   

    Dim dataRC5 As Word    ' 
    Dim countr As Byte    '  
    Dim addr    As Word     '    
    Dim addrRC5 As $00     '  
    Dim clock   As Byte     '  
    Dim h       As Byte    ' 
    Dim j       As Byte    '
    Dim adreeprom As Word  '   
'-------------------------------------------------------------------------------
' 
'-------------------------------------------------------------------------------
    Dim tuner As 86
    Dim tape  As 85
    Dim dvd   As 68
'-------------------------------------------------------------------------------
'      
'-------------------------------------------------------------------------------
'Adress    0   1   2   3   4   5   6   7   
    EData $28,$7b,$6a,$80,$c0,$a0,$e0,$52
    EData $01,$00,$e2,$08,$20,$09,$00,$09
    EData $ce,$08,$0e,$09,$18,$09,$b6,$07
    EData $3a,$09,$de,$07,$e6,$07,$f6,$07
    EData $b0,$08,$c4,$08,$ce,$08,$d6,$08
    EData $f6,$08,$2a,$09,$32,$09,$e2,$08
    EData $e2,$08,$e2,$08,$e2,$08,$e2,$08
    EData $e2,$08,$e2,$08,$e2,$08,$e2,$08
    EData $e2,$08,$e2,$08,$e2,$08,$e2,$08
    EData $e2,$08,$e2,$08,$e2,$08,$e2,$08
    EData $e2,$08,$e2,$08,$e2,$08,$e2,$08
    EData $e2,$08
'-------------------------------------------------------------------------------
'    MK
'-------------------------------------------------------------------------------
    ADCON1 = 7          '  
    ADCON0.0 = 0        ' 
    SSPCON.5 = 0        ' SSP .,  
    TRISB = %00001111   ' 0..3  
    OPTION_REG=%00001000'On pull-up PORTB,   RB0/INT CLK TMR0=1:4
    TRISC = %11000000   ' 
    TRISA = %00000      ' 
    INTCON.7=0          'Disable interapt
    DelayMS 500           ' Wait for LCD to startup ,5 
'-------------------------------------------------------------------------------
'     .   
'      .
'-------------------------------------------------------------------------------
    
    Flag=0          '
    menu_flag=0     ' .
    zero=0
    dataRC5=0
    bak_port= PORTC.6   '   
    
    Vol=ERead 0
    Tre=ERead 1
    Bas=ERead 2 
    Balfl=ERead 3
    Balrl=ERead 4
    Balfr=ERead 5 
    Balrr=ERead 6 
    comutator=ERead 7 
    Channel=ERead 8 
    mono=ERead 9
    adreeprom.BYTE0=adres_ch +Channel *2
    adreeprom.BYTE1=adres_ch +Channel *2+1   
    divisor.BYTE0=ERead adreeprom.BYTE0
    divisor.BYTE1=ERead adreeprom.BYTE1
    
    Loudness=comutator.2
    
    PORTC.5 = mono
    
    GoSub i2c_send
    Print $FE, 1 : DelayMS 30  ' ,  
    Print $FE,$0C : DelayMS 30 
    comutator.2=1
    If comutator =tape Then GoSub lcd_tape
    If comutator =dvd Then GoSub lcd_dvd
    If comutator =tuner Then 
        GoSub control_pll
        GoSub lcd_chanal
    EndIf
    
    GoSub lcd_out
    PORTC.5=mono
    INTCON = %10010000  '  
    On Interrupt GoTo intRB0
    clock= $b0   
    GoTo press
Disable Interrupt
'*******************************************************************************
'       SUBPROGRAMM
'*******************************************************************************
'-------------------------------------------------------------------------------
' 
'-------------------------------------------------------------------------------
loop:
    DelayMS 200
    Return
'-------------------------------------------------------------------------------
'    2. 
'       
'   .
'-------------------------------------------------------------------------------
i2c_send:
    
    BusOut $88, [Vol,Tre,Bas,Balfl,Balfr,Balrl,Balrr,comutator]
    
    
    'I2CWrite SDA,CLK,$88,vol,tre,bas,balfl,balfr,balrl,balrr,comutator, i2c_send
    Return
'===============================================================================
'       LM7001J
'-------------------------------------------------------------------------------
control_pll:
    High e_lm 
    SHOut d_lm, c_lm, 0, [divisor\16, sintez\8]
        ' 0:   ,  010
    Low e_lm    '  
    Return
'===============================================================================
'    
'-------------------------------------------------------------------------------
lcd_out:    

    BranchL Flag,[lcd_vol,lcd_tre,lcd_bas,lcd_bal,lcd_loud,lcd_chanal]
    
lcd_vol:
    If Vol=0 Then
        Print At 2, 1, " Volume:0 dB    "
    Else
        If Vol<8 Then
            Print At 2, 1, " Volume:-", DEC1 (Vol *125/100), ".", DEC2 (Vol*125//100), "dB "
        Else
            Print At 2, 1, " Volume:-", DEC2 (Vol *125/100), ".", DEC2 (Vol*125//100), "dB"
        EndIf
    EndIf
    GoSub loop
    Return

lcd_tre:
    If Tre.3=1 Then
        ind=(7-(Tre -120))*2
        If ind>8 Then
            Print At 2, 1, "  Treble:+", DEC2 ind , "dB  "
        Else
            Print At 2, 1, "  Treble:+", DEC1 ind , "dB   "
        EndIf
    Else
        ind=(7-(Tre -112))*2
        If ind>8 Then
            Print At 2, 1, "  Treble:-", DEC2 ind, "dB  "
        Else
            Print At 2, 1, "  Treble:-", DEC1 ind, "dB   "
        EndIf
    EndIf
    GoSub loop
    Return
    
lcd_bas:
    If Bas.3=1 Then
        ind=(7-(Bas -104))*2
        If ind>8 Then
            Print At 2, 1, "    Bass:+", DEC2 ind, "dB  "
        Else
            Print At 2, 1, "    Bass:+", DEC1 ind, "dB   "
        EndIf
    Else
        ind=(7-(Bas -96))*2
        If ind>8 Then
            Print At 2, 1, "    Bass:-", DEC2 ind, "dB  " 
        Else
            Print At 2, 1, "    Bass:-", DEC1 ind, "dB   "
        EndIf
    EndIf
    GoSub loop
    Return
    
lcd_bal:
    If Balfr>$a0 Then Print At 2, 1, "Balance:R-", DEC1 ((Balfr -$a0)*125)/100,".",DEC2 ((Balfr-$a0)*125)//100, "dB"
    
    If Balfl>$80 Then Print At 2, 1, "Balance:L-", DEC1 ((Balfl -$80)*125)/100,".",DEC2 ((Balfl-$80)*125)//100, "dB"
    If Balfl=$80 And Balfr=$a0 Then Print At 2, 1, "Balance:    0 dB"
    GoSub loop
    Return
    
lcd_loud:
    If comutator.2=1 Then
        Print At 2, 1, "  Loudness OFF  "
    Else
        Print At 2, 1, "  Loudness ON   "
    EndIf
    GoSub loop
    Return
    
lcd_chanal:
    lcdFreq=divisor *5-1070  '   
    If Channel>8 Then
    Print At 1, 1, "Ch",DEC2 (Channel +1)
    Else
    Print At 1, 1, "Ch",DEC1 (Channel +1)," "
    EndIf
    If lcdFreq>=10000 Then
    '   . 
    Print " ", DEC3 (lcdFreq/100), ".", DEC2 (lcdFreq//100), "MHz "
    Else
    '    . 
    Print "  ", DEC2 (lcdFreq/100), ".", DEC2 (lcdFreq//100), "MHz "
    EndIf
lcd_sw:
    If mono=1 Then        
        Print  "m"    
    Else        
        Print  "s"
    EndIf
        
    If menu_flag=0 And Flag=5 Then
        Print At 2, 1, "    Channel     "
    EndIf

    GoSub loop
    Return
    
lcd_tape:
    Print At 1, 1, "      TAPE      "
    Return
    
lcd_dvd:
    Print At 1, 1, "   DVD PLAYER   "
    Return
'-------------------------------------------------------------------------------
'         0
'-------------------------------------------------------------------------------
Disable '   
intRB0:
    INTCON = %00000000  '  
'-------------------------------------------------------------------------------
'   e   RC-5
'-------------------------------------------------------------------------------
    dataRC5=$0001     ' 
    countr=0         '   
    
    While PORTB.0=0 And countr<11  '
    Call timer
    Wend
    If countr>5 And countr<11 Then
        While countr<13            '13    
            Call timer              '  
        Wend
        For h=0 To 12               ' 13 
            dataRC5=dataRC5<<1      '   
            If PORTB.0=1 Then       '
                dataRC5=dataRC5 | $0001 '1   
                countr=0               '  16 
                While PORTB.0=1 And countr<16  ' ,   
                    Call timer                 ' =0
                Wend
            Else
                dataRC5=dataRC5 & $FFFE '0   
                countr=0               '
                While PORTB.0=0 And countr<16 '     =1
                    Call timer                 '
                Wend
            EndIf
            If countr=16 And h<12 Then  '   . 
                dataRC5=0
                GoTo exit       '   
            EndIf
            For j=0 To 11       '   16 (4+12) 
                Call timer
            Next j
        Next h
        addr= dataRC5>>6
        If (addr.LowByte & $1f) <> addrRC5 Then     ' 
            dataRC5=0 
        EndIf
    Else
        dataRC5=0  '
    EndIf
exit:   
    dataRC5=dataRC5 & $3f   ' 0 - 63 (0- )

    INTCON = %10010000  '     
    Resume
'-------------------------------------------------------------------------------
'     
'-------------------------------------------------------------------------------

    ASM
timer
    movf clock,0       ;   
    movwf TMR0
    bcf INTCON,2        ;            
looper
    btfss INTCON,2      ;   
    GoTo looper
    incf countr,1     ;  
    bcf INTCON,2        ; 
    Return
    ENDASM

Enable  '   
'*******************************************************************************
'       MAIN
'-------------------------------------------------------------------------------
'     
'-------------------------------------------------------------------------------
press:
    comutator.2=Loudness
    If dataRC5<>0 Then cmd
    'On Interrupt GoTo intRB0
    'INTCON = %10010000  '     

    For row=0 To 3
        PORTB= ((DCD (row +4))^$ff)  '   +4  0
        'delayms 20
            If PORTB.3=0 Then
                DelayMS 20
                If PORTB.3=0 Then
                Klav=row
                GoTo klaviatura
                EndIf
            EndIf
            If PORTB.2=0 Then
                DelayMS 20
                If PORTB.2=0 Then
                Klav=row +4
                GoTo klaviatura
                EndIf
            EndIf
    Next row
'  
    If bak_port=1 And PORTC.6=0 Then    '  1->0
        If PORTC.7=1 Then               '  
            bak_port= PORTC.6
            Flag=0 : GoTo up
        Else
            bak_port= PORTC.6
            Flag=0 : GoTo down
        EndIf
    Else
        bak_port= PORTC.6
    EndIf
    
    GoTo press
Disable Interrupt    
'  
klaviatura:    
    BranchL Klav,[up,down,left,right,selector,menu,store,sw_st] ',
    
'   
    selector:
    comutator.2=1
    If comutator=tuner Then 
            comutator=dvd '
            
            GoSub lcd_dvd
            GoTo selec 
    EndIf
    If comutator=dvd Then
            comutator=tape
            
            GoSub lcd_tape
            GoTo selec
    EndIf
    If comutator=tape Then 
        comutator=tuner        
        
        GoSub lcd_chanal
    EndIf
    
selec:
    comutator.2=Loudness
    GoSub i2c_send   '    2
    Flag=0
    GoSub lcd_out
    GoSub loop   ' 200 
GoTo press     '   

'-------------------------------------------------------------------------------
'  +
'-------------------------------------------------------------------------------
up:
    dataRC5=0
    BranchL Flag,[vol_up,tre_up,bas_up,bal_up,loud_up,ch_up]
    
'  ( 0 - 0 ;  = 63 (03F))
vol_up:
    If Vol=0 Then press                   '   
    Vol=Vol -2                              ' 
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press     '

'   
tre_up:
    If Tre=120 Then press  '  
    If Tre=$77 Then Tre=$80 '      +
    If Tre>$77 Then         '   "+"  
            Tre=Tre -1
    Else    '   "-"  
            Tre=Tre +1
    EndIf
    
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'   ,   ,   .
bas_up:
    If Bas=104 Then press
    If Bas=$67 Then Bas=$70
    If Bas>$67 Then 
            Bas=Bas -1
    Else
            Bas=Bas +1 
    EndIf
    
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

' 
'   0  -8,75    -1,25 , 
'    . 
bal_up:
    If Balfl=$87 And Balrl=$c7 Then  press
    
    '    
    If Balfr>$a0 And zero=1 Then 
            Balfr=Balfr-1
            Balrr=balrr-1
    EndIf
    '    
    If Balfl>=$80 And zero=0 Then
            Balfl=Balfl +1
            Balrl=Balrl +1
    EndIf
    If Balfr=$a0 Then zero=0    
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'
loud_up:
    If comutator.2=0 Then press
    If comutator.2=1 Then
        comutator.2=0
        Loudness=comutator.2
    EndIf
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'  
ch_up:
    comutator.2=1
    If comutator!=tuner Then press '
             
    If Channel=39 Then press        '   
    Channel=Channel +1
ch_rc:
    If menu_flag=1 Then             ' .
        GoSub lcd_chanal  '  
        
        GoTo press
    EndIf
    adreeprom.BYTE0=adres_ch +Channel *2
    adreeprom.BYTE1=adres_ch +Channel *2+1   
    divisor.BYTE0=ERead adreeprom.BYTE0
    divisor.BYTE1=ERead adreeprom.BYTE1
    GoSub control_pll   '   
    GoSub lcd_chanal  '  
    
    GoTo press
    
' \
sw_st:
    comutator.2=1
    If comutator!=tuner Then press '
    
    If mono=1 Then
        mono=0            
    Else
        mono=1        
    EndIf
    PORTC.5=mono
    GoSub lcd_chanal
    GoTo press
    
'-------------------------------------------------------------------------------
'   "-"
'-------------------------------------------------------------------------------                                                                                                   
down:
    dataRC5=0
    BranchL Flag,[vol_down,tre_down,bas_down,bal_down,loud_down,ch_down]
    
'  
vol_down:
    If Vol=62 Then press    '    
    Vol=Vol +2                              '     
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press     '
    
'   
tre_down:
    If Tre=$70 Then press  '   
    If Tre=$7f Then Tre=$77 '    "+"  "-"
    If Tre>$77 Then
            Tre=Tre +1
    EndIf
    If Tre<$78 Then
            Tre=Tre -1            
    EndIf
    
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'   
bas_down:
    If Bas=$60 Then press   '
    If Bas=$6f Then Bas=$67 '
    If Bas>$67 Then
            Bas=Bas +1
    EndIf
    If Bas<$68 Then
            Bas=Bas -1 
    EndIf
    
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'  .
'   0  -8,75    -1,25 , 
'    .
bal_down:
    If Balfr=$a7 And Balrr=$e7 Then press   '     
    If Balfl>$80 And zero=0 Then    '      0  
            Balfl=Balfl -1
            Balrl=Balrl -1
    EndIf               '
    If Balfr >=$a0 And zero=1 Then     ' .       
            Balfr=Balfr +1
            Balrr=Balrr +1 
    EndIf
    
    If Balfl=$80 Then zero=1
            
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'
loud_down:
    If comutator.2=1 Then press
    If comutator.2=0 Then
        comutator.2=1
        Loudness=comutator.2
    EndIf
    GoSub i2c_send
    GoSub lcd_out
GoTo press'goto press

'   
ch_down:
    comutator.2=1
    If comutator!=tuner Then press       '
         
    
    If Channel=0 Then press              ' MIN  

    Channel=Channel -1
    If menu_flag=1 Then             ' .
        GoSub lcd_chanal  '  
        
        GoTo press
    EndIf
    adreeprom.BYTE0=adres_ch +Channel *2
    adreeprom.BYTE1=adres_ch +Channel *2+1   
    divisor.BYTE0=ERead adreeprom.BYTE0
    divisor.BYTE1=ERead adreeprom.BYTE1
    
    GoSub control_pll   '       
    GoSub lcd_chanal  '  
    
    GoTo press
    
'-------------------------------------------------------------------------------
'  
left:
'   
    If menu_flag=1 Then
        If divisor=1964 Then    '  
            divisor=2374        '  . . 
            GoSub control_pll   '       
            GoSub lcd_chanal  '  
        
            GoTo press
        EndIf

        divisor=divisor -1
        GoSub control_pll   '       
        GoSub lcd_chanal  '  
        
        GoTo press
    EndIf
'   
    comutator.2=1 
    If Flag=0 And comutator=tuner Then
        Flag=5
        
        GoTo set_jump
    EndIf
    If Flag=0 Then
        Flag=4
        GoTo set_jump
    EndIf
    
    Flag=Flag -1
set_jump:
    comutator.2=Loudness    
    GoSub lcd_out
    GoTo press

    
'  
right:
'   
    If menu_flag=1 Then
        If divisor=2374 Then    '  
            divisor=1964        '  . . 
            GoSub control_pll   '       
            GoSub lcd_chanal  '  
            
            GoTo press
        EndIf

        divisor=divisor +1
        GoSub control_pll   '       
        GoSub lcd_chanal  '  
        
        GoTo press
    EndIf
'   ()
    comutator.2=1
    If comutator=tuner And Flag=5 Then  '   
        Flag=0
        
        GoTo  set_jump
    EndIf
    If Flag=4 And comutator!=tuner Then '   
        Flag=0
        
        GoTo set_jump
    EndIf
    Flag=Flag +1
    GoTo set_jump
    
'-------------------------------------------------------------------------------
'    . 
'-------------------------------------------------------------------------------
menu:
    comutator.2=1
    If comutator=tape Or comutator=dvd Then press
        
    If menu_flag=1 Then
        menu_flag=0
        Flag=0          '*   
        
        GoTo set_jump   '     
    EndIf
    If menu_flag=0 Then 
        menu_flag=1
        Flag=5          '
        
    EndIf
    
    Print At 2,1, "Channel+- Freq<>"
    GoSub lcd_chanal     '    
    GoTo press'goto press
    
'       ,     10
store:

    Print At 2,1, "     Stored     " 
           
    EWrite 0, [Vol, Tre, Bas, Balfl, Balrl, Balfr, Balrr]
 
    EWrite 7, [comutator, Channel, mono]
       
    EWrite adres_ch +Channel *2, [divisor.BYTE0]
    EWrite adres_ch +Channel *2 +1, [divisor.BYTE1]     
    
    DelayMS 1000
    If menu_flag=1 Then 
        Print At 2,1 ,"Channel+- Freq<>"
    Else
        GoSub lcd_out
    EndIf
    GoTo press'goto press
                

'===============================================================================
' 
'-------------------------------------------------------------------------------
cmd:
' ,     +/-
    If dataRC5<$16 And dataRC5>=$10 And dataRC5.0=0 Then
        Flag=(dataRC5 -$10)/2
        GoTo up
    EndIf
    If dataRC5<$16 And dataRC5>=$10 And dataRC5.0=1 Then
        Flag=(dataRC5 -$11)/2
        GoTo down
    EndIf
'  1-9
    If dataRC5<=9 Then
        comutator.2=1
        If comutator!=tuner Then press
        Channel=dataRC5 -1
        GoTo ch_rc
    EndIf
'  +/-
    If dataRC5=$20 Then
        Flag=5
        GoTo up
    EndIf
    If dataRC5=$21 Then
        Flag=5
        GoTo down
    EndIf
'  +/-
    If dataRC5=$1c Then
        Flag=3
        GoTo up
    EndIf
    If dataRC5=$1d Then
        Flag=3
        GoTo down
    EndIf
' 
    If dataRC5=$1e Then
        dataRC5=0
        GoTo selector
    EndIf
'  
    If dataRC5=$29 Then
        dataRC5=0
        GoTo store
    EndIf
'   
dataRC5=0
GoTo press       
'-------------------------------------------------------------------------------    
 'enable
    End

'===============================================================================

